	 title	'HLTIDLE - Issue HLT during idle loops'
code	 segment para 'code'
	 assume cs:code,ds:code
kbdflag  equ	56h
dskflag  equ	57h
base	 equ	58h
	 org	100h
entry:	 mov	ax,352ah		;Get vector function
	 int	21h			;Call DOS
	 mov	di,bx			;Load DI with vector offset
	 mov	si,offset idle		;Point to idle code
	 mov	cx,pass2a-idle		;Load length
	 repe	cmpsb			;Compare
	 je	err			;Exit if already installed
	 mov	old2a,bx		;Store INT 2A vector
	 mov	old2a+2,es
	 cmp	byte ptr es:[bx],0cfh	;IRET ?
	 jne	@f			;No
	 mov	byte ptr pass2a,0cfh	;Replace JMP with IRET
@@:	 mov	ax,3515h		;Get vector function
	 int	21h			;Call DOS
	 mov	old15,bx		;Store INT 15 vector
	 mov	old15+2,es
	 mov	bp,cs			;Load code segment
	 mov	si,81h			;Point to parameters
@@:	 mov	ax,[si] 		;Get characters
	 inc	si			;Point to next character
	 cmp	al,' '			;Space ?
	 je	@b			;Yes, iterate loop
	 and	ax,0dfdfh		;Uppercase characters
	 cmp	ax,'OL' 		;LO ?
	 jne	@f			;No
	 cmp	byte ptr [si+1],' '	;Delimiter ?
	 ja	@f			;No
	 mov	bp,50h			;Load BIOS data area segment
@@:	 mov	es,bp			;Load ES with code segment
	 mov	dx,base 		;Load DX with new INT 2A offset
	 mov	di,dx			;Load DI with offset
	 mov	si,offset idle		;Point to idle code
	 mov	cx,idlelen		;Load code length
	 rep	movsb			;Copy idle code
	 and	word ptr es:[kbdflag],0 ;Zero flags
	 mov	ds,bp			;Load DS with code segment
	 mov	ax,252ah		;Set vector function
	 int	21h			;Call DOS
	 mov	dx,base+idle15-idle	;Load DX with new INT 15 offset
	 mov	ax,2515h		;Set vector function
	 int	21h			;Call DOS
	 push	cs			;Get CS
	 pop	ds			;Set DS = CS
	 mov	dx,offset instmsg	;Point DX at message
	 mov	ah,09h			;Display string function
	 int	21h			;Call DOS
	 cmp	bp,50h			;Was LO specified ?
	 je	exit			;Yes
	 mov	es,ds:[2ch]		;Get environment segment
	 mov	ah,49h			;Release memory function
	 int	21h			;Call DOS
	 mov	dx,reslen		;Load resident size
	 mov	ax,3100h		;Terminate function
	 int	21h			;Return to DOS
err:	 mov	dx,offset errmsg	;Point DX at message
	 mov	ah,09h			;Display string function
	 int	21h			;Call DOS
exit:	 mov	ax,4c00h		;Terminate function
	 int	21h			;Return to DOS

idle:	 cmp	ah,84h			;Keyboard idle callout ?
	 jne	pass2a			;No
	 sti				;Enable interrupts
	 hlt				;Halt
	 cli				;Disable interrupts
pass2a	 label	near
	 db	0eah			;Jump to previous INT 2A vector
old2a	 dw	0,0

idle15:  cmp	ax,9001h		;Floppy drive busy call ?
	 jne	chk9101 		;No
	 push	ax			;Save AX
	 push	ds			;Save DS
	 xor	ax,ax			;Load 0
	 mov	ds,ax			;Set DS = 0
	 test	byte ptr ds:[43fh],0fh	;Any floppy drive active ?
	 jz	dskdone 		;No
	 mov	cs:[dskflag],al 	;Indicate floppy drive busy
	 sti				;Enable interrupts
dskwait: hlt				;Halt
	 cmp	cs:[dskflag],al 	;Floppy drive busy ?
	 jne	dskdone 		;No
	 test	byte ptr ds:[43fh],0fh	;Any floppy drive active ?
	 jnz	dskwait 		;Yes, iterate loop
	 stc				;Indicate timeout occurred
dskdone: pop	ds			;Restore DS
	 pop	ax			;Restore AX
	 retf	2			;Return
chk9101: cmp	ax,9101h		;Floppy drive post call ?
	 jne	chkkbd			;No
	 mov	cs:[dskflag],al 	;Indicate floppy drive ready
	 iret				;Return

chkkbd:  cmp	ax,9002h		;Keyboard busy call ?
	 jne	chkpost 		;No
	 mov	cs:[kbdflag],ah 	;Set keyboard busy flag
	 sti				;Enable interrupts
kbdwait: hlt				;Halt
	 cmp	cs:[kbdflag],ah 	;Keyboard busy ?
	 je	kbdwait 		;Yes
	 iret				;Return
chkpost: cmp	ax,9102h		;Keyboard post call ?
	 jne	pass15			;No
	 mov	cs:[kbdflag],ah 	;Clear keyboard busy flag
	 iret				;Return

pass15	 label	near
	 db	0eah			;Jump to previous INT 15 vector
old15	 dw	0,0
idlelen  equ	$-idle
reslen	 equ	($-idle+base+15)/16

instmsg  db	'HLTIDLE installed',13,10,'$'
errmsg	 db	'HLTIDLE already installed',13,10,'$'
code	 ends
	 end	entry
